// matpage.cpp : implementation file
//

#include "stdafx.h"
#include "..\Include\3dPlus.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMatPage property page

IMPLEMENT_DYNCREATE(CMatPage, CClrBasePage)

CMatPage::CMatPage() : CClrBasePage(CMatPage::IDD)
{
	//{{AFX_DATA_INIT(CMatPage)
	//}}AFX_DATA_INIT
	m_dSharp = 5.0;	 // 0 - 20
	m_dShine = 1.0;	 // 0 - 1
}

CMatPage::~CMatPage()
{
}

void CMatPage::DoDataExchange(CDataExchange* pDX)
{
	CClrBasePage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMatPage)
	DDX_Control(pDX, _3D_IDC_SHINE, m_sbShine);
	DDX_Control(pDX, _3D_IDC_SHARP, m_sbSharp);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMatPage, CClrBasePage)
	//{{AFX_MSG_MAP(CMatPage)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMatPage message handlers

BOOL CMatPage::OnSetActive() 
{
	m_sbShine.SetScrollRange(0, 100);
	m_sbSharp.SetScrollRange(0, 100);

	m_sbShine.SetScrollPos((int)(m_dShine * 100));
	m_sbSharp.SetScrollPos((int)(m_dSharp * 5));

	return TRUE;
}

void CMatPage::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// update the position
	int iPos = pScrollBar->GetScrollPos();
	switch(nSBCode) {
	case SB_LINELEFT:
		iPos -= 1;
		break;
	case SB_PAGELEFT:
		iPos -= 10;
		break;
	case SB_LINERIGHT:
		iPos += 1;
		break;
	case SB_PAGERIGHT:
		iPos += 10;
		break;
	case SB_THUMBTRACK:
	case SB_THUMBPOSITION:
		iPos = nPos;
		break;
	default:
		return;
	}
	if (iPos < 0) {
		iPos = 0;
	} else if (iPos > 100) {
		iPos = 100;
	}
	pScrollBar->SetScrollPos(iPos);

	// now grab the current positions, set the values
	// and update the shape material
	m_dShine = m_sbShine.GetScrollPos() / 100.0;
	m_dSharp = m_sbSharp.GetScrollPos() / 5.0;

	ASSERT(m_pDlg);
	C3dShape* pShape = m_pDlg->GetShape();
	if (pShape) {
		pShape->SetMaterial(m_dSharp);
	}

}

